//========================================================================================
//
//	File:				FWOrdCol.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWORDCOL_H
#define FWORDCOL_H

#ifndef PRORDCOL_H
#include "PROrdCol.h"
#endif

#ifndef FWEXCLIB_H
#include "FWExcLib.h"
#endif

//========================================================================================
// Forward Class Declarations
//========================================================================================

class FW_CPrivLinkedListIterator;
class FW_CPrivLinkedList;

//========================================================================================
// Class FW_CPrivOrderedCollection
//========================================================================================

class FW_CPrivOrderedCollection
{
public:
	FW_DECLARE_AUTO(FW_CPrivOrderedCollection)
	friend class  FW_CPrivOrderedCollectionIterator;
	
//----------------------------------------------------------------------------------------
//	Constructors/Destructor
//
public:
	FW_CPrivOrderedCollection(FW_OrderedCollection_MatchProc matchProc);
	~FW_CPrivOrderedCollection();

//----------------------------------------------------------------------------------------
//	Data Members
//
protected:
	FW_HLinkedList						fImplementation;
	FW_OrderedCollection_MatchProc		fMatchProc;
};

//========================================================================================
// Class FW_CPrivOrderedCollectionIterator
//========================================================================================

class FW_CPrivOrderedCollectionIterator 
{
public:
	FW_DECLARE_AUTO(FW_CPrivOrderedCollectionIterator)

//----------------------------------------------------------------------------------------
//	Constructors/Destructor
//
public:
	FW_CPrivOrderedCollectionIterator(const FW_CPrivOrderedCollection* collection);
	~FW_CPrivOrderedCollectionIterator();
	
//----------------------------------------------------------------------------------------
//	Data Members
//
protected:
	FW_HLinkedListIterator 		fImplementation;
};

#endif
