//========================================================================================
//
//	File:				SLDebug.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef SLDEBUG_H
#define SLDEBUG_H

#ifndef FWENVDEF_H
#include "FWEnvDef.h"
#endif


FW_EXTERN_C_BEGIN

//========================================================================================
//	struct FW_SDebugConsole
//		This struct defines a debug console.  All methods defined by FW_CDebugConsole 
//		are handled by the procedures pointed to by an instance of this struct.
//
//			fDoAssertMessage	- called by FW_CDebugConsole::AssertMesssage(message)
//			fDoFatalMessage		- called by FW_CDebugConsole::Debugger(message)
//			fDoDebugMessage		- called by FW_CDebugConsole::DebugMessage(message)
//			fDoLogMessage		- called by FW_CDebugConsole::LogMessage(message)
//			fDoDebugger			- called by FW_CDebugConsole::Debugger()
//			fPrivate			- expansion hook.  initialize to 0.
//			fUserInfo			- do as thou willt
//
//========================================================================================

struct FW_SDebugConsole
{
	void (*fDoAssertMessage)(FW_SDebugConsole* self, const char* message);
	void (*fDoFatalMessage)(FW_SDebugConsole* self, const char* message);
	void (*fDoDebugMessage)(FW_SDebugConsole* self, const char* message);
	void (*fDoLogMessage)(FW_SDebugConsole* self, const char* message);
	void (*fDoDebugger)(FW_SDebugConsole* self);
	void *fPrivate;
	
	void* fUserInfo;
};


//========================================================================================
//	Exported routines
//========================================================================================

// Export or Import functions for CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif

FW_EXPORT FW_SDebugConsole* FW_PrivDebugConsole_GetConsole();
FW_EXPORT FW_SDebugConsole* FW_PrivDebugConsole_SetConsole(FW_SDebugConsole* console);

FW_EXTERN_C_END

// For CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif

#endif
