//========================================================================================
//
//	File:				SLMemMgr.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef SLMEMMGR_H
#define SLMEMMGR_H

#include <stddef.h>

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#if defined(FW_BUILD_MAC) && !defined(__MEMORY__)
#include <Memory.h>
#endif

#if defined(FW_BUILD_MAC) && !defined(__ERRORS__)
#include <Errors.h>
#endif

#ifdef FW_BUILD_WIN32

#include <Windows.h>

// Windows 32 API macro that conflicts with a method in FW_CMemoryManager
#ifdef CopyMemory
#undef CopyMemory
#endif

#endif

// Export or Import functions for CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif

FW_EXTERN_C_BEGIN

//========================================================================================
// Forward class declarations
//========================================================================================

struct MemHeap;

//========================================================================================
// External procedure definitions
//========================================================================================

extern void FW_PrivMemoryManager_CopyMemory(const void* const source,
											void* const destination,
											unsigned long bytesToMove);
extern void FW_PrivMemoryManager_SetMemory(void* aBlock,
										   unsigned long bytesToSet,
										   unsigned char byteValue);
extern void* FW_PrivMemoryManager_AddOffsetToPointer(void* pointer, unsigned long Offset);

extern void* FW_PrivMemoryManager_AllocateBlock(unsigned long bytesRequested);
extern void* FW_PrivMemoryManager_ResizeBlock(void* aBlock, unsigned long bytesRequested);
extern unsigned long FW_PrivMemoryManager_GetBlockSize(const void* aBlock);
extern void FW_PrivMemoryManager_FreeBlock(void* aBlock);

extern FW_PlatformHandle FW_PrivMemoryManager_AllocateSystemHandle(unsigned long bytesRequested);
extern FW_PlatformHandle FW_PrivMemoryManager_ResizeSystemHandle(FW_PlatformHandle aHandle,
																	unsigned long bytesRequested);
extern void FW_PrivMemoryManager_FreeSystemHandle(FW_PlatformHandle aHandle);
extern void* FW_PrivMemoryManager_LockSystemHandle(FW_PlatformHandle aHandle);
extern void FW_PrivMemoryManager_UnlockSystemHandle(FW_PlatformHandle aHandle);
extern unsigned long FW_PrivMemoryManager_GetSystemHandleSize(FW_PlatformHandle aHandle);
extern FW_PlatformHandle FW_PrivMemoryManager_CopySystemHandle(FW_PlatformHandle aHandle);

FW_EXTERN_C_END

// For CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif


#endif
