//========================================================================================
//
//	File:				FWIntere.cpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWFound.hpp"

#ifndef FWINTERE_H
#include "FWIntere.h"
#endif

#ifndef FWNOTIFR_H
#include "FWNotifr.h"
#endif

#ifndef FWTCOLL_H
#include "FWTColl.h"
#endif

#ifndef FWDEBUG_H
#include "FWDebug.h"
#endif

//========================================================================================
//	Template Instantiations
//========================================================================================

FW_DEFINE_AUTO_TEMPLATE(FW_TOrderedCollectionIterator, FW_CInterest)
FW_DEFINE_AUTO_TEMPLATE(FW_TOrderedCollection, FW_CInterest)

#ifdef FW_USE_TEMPLATE_PRAGMAS

#pragma template_access public
#pragma template FW_TOrderedCollection<FW_CInterest>
#pragma template FW_TOrderedCollectionIterator<FW_CInterest>

#endif

//========================================================================================
// CLASS FW_CInterest
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_CInterest::FW_CInterest
//----------------------------------------------------------------------------------------

FW_CInterest::FW_CInterest() :
	fNotifier(NULL),
	fMessage(0)
{
}

//----------------------------------------------------------------------------------------
// FW_CInterest::FW_CInterest
//----------------------------------------------------------------------------------------

FW_CInterest::FW_CInterest(FW_MNotifier* notifier, FW_Message msg) :
	fNotifier(notifier),
	fMessage(msg)
{
}

//----------------------------------------------------------------------------------------
// FW_CInterest::FW_CInterest
//----------------------------------------------------------------------------------------

FW_CInterest::FW_CInterest(const FW_CInterest& other) :
	fNotifier(other.fNotifier),
	fMessage(other.fMessage)
{
}

//----------------------------------------------------------------------------------------
// FW_CInterest::~FW_CInterest
//----------------------------------------------------------------------------------------

FW_CInterest::~FW_CInterest()
{
}

//----------------------------------------------------------------------------------------
// FW_CInterest::operator=
//----------------------------------------------------------------------------------------
	
FW_CInterest& FW_CInterest::operator=(const FW_CInterest& other)
{
	fNotifier = other.fNotifier;
	fMessage = other.fMessage;
	
	return *this;
}

//----------------------------------------------------------------------------------------
// FW_CInterest::operator==
//----------------------------------------------------------------------------------------

FW_Boolean FW_CInterest::operator==(const FW_CInterest& other) const
{
	return fNotifier == other.fNotifier && fMessage == other.fMessage;
}
