//========================================================================================
//
//	File:				FWNotifn.cpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWFound.hpp"

#ifndef FWNOTIFN_H
#include "FWNotifn.h"
#endif

#ifndef FWPRIDEB_H
#include "FWPriDeb.h"
#endif

//========================================================================================
// CLASS FW_CNotification
//========================================================================================

FW_DEFINE_CLASS_M0(FW_CNotification)

//----------------------------------------------------------------------------------------
// FW_CNotification::FW_CNotification
//----------------------------------------------------------------------------------------

FW_CNotification::FW_CNotification() :
	fInterest(NULL)
{
}

FW_CNotification::FW_CNotification(const FW_CInterest& interest) :
	fInterest(NULL)
{
	fInterest = new FW_CInterest(interest);
}

FW_CNotification::FW_CNotification(const FW_CNotification& other) :
	fInterest(other.fInterest)
{
}

//----------------------------------------------------------------------------------------
// FW_CNotification::~FW_CNotification
//----------------------------------------------------------------------------------------

FW_CNotification::~FW_CNotification()
{
}

//----------------------------------------------------------------------------------------
// FW_CNotification::SetInterest
//----------------------------------------------------------------------------------------

void FW_CNotification::SetInterest(const FW_CInterest& interest) 
{
	FW_ASSERT(fInterest == NULL);
	
	fInterest = new FW_CInterest(interest);
}

//----------------------------------------------------------------------------------------
// FW_CNotification::operator==
//----------------------------------------------------------------------------------------

FW_Boolean FW_CNotification::operator==(const FW_CNotification& other)
{
	return *fInterest == *(other.fInterest);
}

//----------------------------------------------------------------------------------------
// FW_CNotification::operator=
//----------------------------------------------------------------------------------------

FW_CNotification& FW_CNotification::operator=(const FW_CNotification& other)
{
	fInterest = other.fInterest;
	return *this;
}

