//========================================================================================
//
//	File:				FWClaImp.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWCLAIMP_H
#define FWCLAIMP_H

#ifndef FWBLDDEF_H
#include "FWBldDef.h"
#endif

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef SLPRIDEB_H
#include "SLPriDeb.h"
#endif

#if defined(FW_BUILD_MAC) && !defined(__TYPES__)
#include <Types.h>
#endif

#include <stddef.h>

//========================================================================================
// CLASS FW_SClassInfo
//========================================================================================

FW_EXTERN_C_BEGIN

struct FW_SClassInfo;
typedef const FW_SClassInfo *FW_SClassInfoPtr;

struct FW_SClassInfo
{
	const char *fClassName;
		// Name of the class

	size_t fInstanceSize;
		// Size of instances of the class
		
	FW_SClassInfoPtr const * fAncestors;
		// ClassInfo for ancestors of the class.
		// Pointer to array of const pointers to const FW_SClassInfo
	
	const size_t *fAncestorOffsets;
};

void* FW_PrivDynamicCast(const void* p, 
						FW_SClassInfoPtr fromDynamicClass, 
						FW_SClassInfoPtr fromStaticClass, 
						FW_SClassInfoPtr toStaticClass);

FW_EXTERN_C_END

#endif
