//========================================================================================
//
//	File:				FWEveDef.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWEVEDEF_H
#define FWEVEDEF_H

#if defined(FW_BUILD_MAC) && !defined(__EVENTS__)
#include <Events.h>
#endif

#if defined(FW_BUILD_WIN) && !defined(_INC_WINDOWS)
#include <windows.h>
#endif

//========================================================================================
//	Global defines
//========================================================================================

// ------ Virtual keys --------

#ifdef FW_BUILD_MAC
#define FW_kVKBackspace		0x33
#define FW_kVKTab			0x30
#define FW_kVKClear			0x47
#define FW_kVKReturn		0x24
#define FW_kVKShift			0x38
#define FW_kVKControl		0x3b
#define FW_kVKCommand		0x37
#define FW_kVKOption		0x3a
#define FW_kVKEscape		0x35
#define FW_kVKSpace			0x31
#define	FW_kVKPageUp		0x74
#define	FW_kVKPageDown		0x79
#define FW_kVKEnd			0x77
#define	FW_kVKHome			0x73
#define FW_kVKLeft			0x7b
#define FW_kVKUp			0x7e
#define	FW_kVKRight			0x7c
#define FW_kVKDown			0x7d
#define FW_kVKInsert		0x2d
#define FW_kVKDelete		0x75
#define FW_kVKNumpad0		0x52
#define FW_kVKNumpad1		0x53
#define FW_kVKNumpad2		0x54
#define FW_kVKNumpad3		0x55
#define FW_kVKNumpad4		0x56
#define FW_kVKNumpad5		0x57
#define FW_kVKNumpad6		0x58
#define FW_kVKNumpad7		0x59
#define FW_kVKNumpad8		0x5b
#define FW_kVKNumpad9		0x5c
#define FW_kVKEnter			0x4c
#define FW_kVKMultiply		0x43
#define FW_kVKAdd			0x45
#define FW_kVKSubtract		0x4e
#define FW_kVKDivide		0x4b
#define FW_kVKDecimal		0x41
#define FW_kVKEqual			0x51
#define FW_kVKF1			0x7a
#define FW_kVKF2			0x78
#define FW_kVKF3			0x63
#define FW_kVKF4			0x76
#define FW_kVKF5			0x60
#define FW_kVKF6			0x61
#define FW_kVKF7			0x62
#define FW_kVKF8			0x64
#define FW_kVKF9			0x65
#define FW_kVKF10			0x6d
#define FW_kVKF11			0x67
#define FW_kVKF12			0x6f
#define FW_kVKF13			0x69
#define FW_kVKF14			0x6b
#define FW_kVKF15			0x71
#endif

#ifdef FW_BUILD_WIN
#define FW_kVKBackspace		VK_BACK
#define FW_kVKTab			VK_TAB
#define FW_kVKClear 		VK_CLEAR
#define FW_kVKReturn		VK_RETURN
#define FW_kVKShift			VK_SHIFT
#define FW_kVKControl		VK_CONTROL
#define FW_kVKCommand		VK_MENU
#define FW_kVKEscape		VK_ESCAPE
#define FW_kVKSpace			VK_SPACE
#define	FW_kVKPageUp		VK_PRIOR
#define	FW_kVKPageDown		VK_NEXT
#define FW_kVKEnd			VK_END
#define	FW_kVKHome			VK_HOME
#define FW_kVKLeft			VK_LEFT
#define FW_kVKUp			VK_UP
#define	FW_kVKRight			VK_RIGHT
#define FW_kVKDown			VK_DOWN
#define FW_kVKInsert		VK_INSERT
#define FW_kVKDelete		VK_DELETE
#define FW_kVKNumpad0		VK_NUMPAD0
#define FW_kVKNumpad1		VK_NUMPAD1
#define FW_kVKNumpad2		VK_NUMPAD2
#define FW_kVKNumpad3		VK_NUMPAD3
#define FW_kVKNumpad4		VK_NUMPAD4
#define FW_kVKNumpad5		VK_NUMPAD5
#define FW_kVKNumpad6		VK_NUMPAD6
#define FW_kVKNumpad7		VK_NUMPAD7
#define FW_kVKNumpad8		VK_NUMPAD8
#define FW_kVKNumpad9		VK_NUMPAD9
#define FW_kVKEnter			VK_EXECUTE
#define FW_kVKMultiply		VK_MULTIPLY
#define FW_kVKAdd			VK_ADD
#define FW_kVKSubtract		VK_SUBTRACT
#define FW_kVKDivide		VK_DIVIDE
#define FW_kVKDecimal		VK_DECIMAL
#define FW_kVKEqual			VK_SEPARATOR
#define FW_kVKF1			VK_F1
#define FW_kVKF2			VK_F2
#define FW_kVKF3			VK_F3
#define FW_kVKF4			VK_F4
#define FW_kVKF5			VK_F5
#define FW_kVKF6			VK_F6
#define FW_kVKF7			VK_F7
#define FW_kVKF8			VK_F8
#define FW_kVKF9			VK_F9
#define FW_kVKF10			VK_F10
#define FW_kVKF11			VK_F11
#define FW_kVKF12			VK_F12
#define FW_kVKF13			VK_F13
#define FW_kVKF14			VK_F14
#define FW_kVKF15			VK_F15
#endif

#endif
