//========================================================================================
//
//	File:				FWEventU.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWEVENTU_H
#define FWEVENTU_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef FWEVEDEF_H
#include "FWEveDef.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class ODWindow;
class ODFacet;
class FW_CPoint;
class FW_CGraphicContext;
struct Environment;

//========================================================================================
//	Global Utilities
//========================================================================================

//========================================================================================
//	Global Utilities
//========================================================================================

// ----- Key pressed
FW_Boolean FW_IsShiftKeyPressed();
FW_Boolean FW_IsOptionKeyPressed();
FW_Boolean FW_IsCommandKeyPressed();
FW_Boolean FW_IsControlKeyPressed();
FW_Boolean FW_IsKeyPressed(unsigned short theKey);

FW_CPoint	FW_GetMouseLocation(ODWindow* theODWindow, FW_CGraphicContext& theGC);
FW_CPoint	FW_GetMouseLocation(Environment* ev, ODFacet* facet);

FW_Boolean	FW_WaitMouseUp();

void		FW_WaitFor(long tickCount);

//========================================================================================
//	Global Inline Methods
//========================================================================================

//----------------------------------------------------------------------------------------
// ::FW_IsShiftKeyPressed
//----------------------------------------------------------------------------------------

inline FW_Boolean FW_IsShiftKeyPressed()
{
	return ::FW_IsKeyPressed(FW_kVKShift);
}

//----------------------------------------------------------------------------------------
// ::FW_IsCommandKeyPressed
//----------------------------------------------------------------------------------------

inline FW_Boolean FW_IsCommandKeyPressed()
{
	return ::FW_IsKeyPressed(FW_kVKCommand);
}

//----------------------------------------------------------------------------------------
// ::FW_IsControlKeyPressed
//----------------------------------------------------------------------------------------

inline FW_Boolean FW_IsControlKeyPressed()
{
	return ::FW_IsKeyPressed(FW_kVKControl);
}

#ifdef FW_BUILD_MAC
//----------------------------------------------------------------------------------------
// ::FW_IsOptionKeyPressed
//----------------------------------------------------------------------------------------

inline FW_Boolean FW_IsOptionKeyPressed()
{
	return ::FW_IsKeyPressed(FW_kVKOption);
}
#endif

#endif

