//========================================================================================
//
//	File:				FWTabber.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWTABBER_H
#define FWTABBER_H

#ifndef FWEVENTH_H
#include "FWEventH.h"
#endif

#ifndef FWEVEDEF_H
#include "FWEveDef.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

struct Environment;

class FW_CView;
class FW_CSuperView;

//========================================================================================
//	class FW_CViewTabber
//========================================================================================

class FW_CViewTabber : public FW_MEventHandler
{
public:
	FW_DECLARE_CLASS

// ----- Construction
	FW_CViewTabber(Environment* ev, FW_CSuperView* parent, short tabbingKey = FW_kVKTab);
	virtual	~FW_CViewTabber();

// ----- Inherited from FW_MEventHandler

	virtual FW_Boolean 	DoVirtualKey(Environment* ev, const FW_CVirtualKeyEvent& theVirtualKeyEvent);

// ----- New API

	short			GetTabbingKey();
	void			SetTabbingKey(short key);

	virtual void 	Tab(Environment* ev, FW_CSuperView* parent, FW_Boolean tabBackward = FALSE);

private:	
	void			Reset();
	void			FindTargets(Environment* ev, FW_CSuperView* parent, FW_Boolean tabBackward);

// ----- Data
private:
	FW_CSuperView*	fParentView;	// top view for this tabber
	FW_CView*		fFirstView;		// first view for wrap-around
	FW_CView*		fNextView;		// view to become the new target
	FW_Boolean		fFoundCurrent;
	short			fTabbingKey;	// it's Tab by default
};

//========================================================================================
//	FW_CViewTabber inlines
//========================================================================================

inline void FW_CViewTabber::Reset()
{
	fFirstView = fNextView = NULL;
	fFoundCurrent = FALSE;
}

inline	short FW_CViewTabber::GetTabbingKey()
{
	return fTabbingKey;
}

inline	void FW_CViewTabber::SetTabbingKey(short key)
{
	fTabbingKey = key;
}

#endif // FWTABBER_H

