//========================================================================================
//
//	File:				FWAplEvt.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWAPLEVT_H
#define FWAPLEVT_H

#ifndef FWDESC_H
#include "FWDesc.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class ODAppleEvent;
class FW_CPart;
class FW_MScriptable;

//========================================================================================
//	class FW_CAppleEvent
//========================================================================================

class FW_CAppleEvent : public FW_CDesc
{
public:
	FW_DECLARE_AUTO(FW_CAppleEvent)
	
	FW_CAppleEvent();
	FW_CAppleEvent(ODAppleEvent* odAppleEvent);
	
	virtual ~FW_CAppleEvent();
	
	FW_Boolean 	HasAttributeKey(ODDescType key) const;
	void 		GetAttributeByKey(AEKeyword key, FW_CDesc& desc, ODDescType desiredType = typeWildCard) const;
	
	FW_Boolean	HasSubject() const;
	void		GetSubject(FW_CDesc& subjectDesc) const;
	
	AEKeyword 	GetEventClass() const;
	AEKeyword 	GetEventID() const;
	
	operator	ODAppleEvent*() const;
	operator	ODAppleEvent**();
	
protected:
	
	virtual ODDesc* PrivCreateODDesc(Environment* ev) const;
};

//========================================================================================
//	Utility Functions
//========================================================================================

short FW_MakeSetLocalPropertyEvent(Environment* ev, 
								FW_CPart* part, 
								FW_MScriptable* theObject,
								ODDescType whichProperty,
								FW_CDesc& newValue,
								FW_CAppleEvent& setPropertyEvent);


#endif // FWAPLEVT_H