//========================================================================================
//
//	File:				FWDscOpr.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWDSCOPR_H
#define FWDSCOPR_H

#ifndef FWDESC_H
#include "FWDesc.h"
#endif

//========================================================================================
//	forward declarations
//========================================================================================

class FW_CPropertyDesignator;
class FW_CColor;
class FW_CString;
class FW_MScriptable;

FW_CDesc& operator<< (FW_CDesc& desc, const FW_CDesc& other);	
const FW_CDesc& operator>> (const FW_CDesc& desc, FW_CDesc& other);

FW_CDesc& operator<< (FW_CDesc& desc, ODDescType typeValue);	
const FW_CDesc& operator>> (const FW_CDesc& desc, ODDescType& typeValue);

FW_CDesc& operator<< (FW_CDesc& desc, long value);	
const FW_CDesc& operator>> (const FW_CDesc& desc, long& value);

FW_CDesc& operator<< (FW_CDesc& desc, const FW_CColor& color);
const FW_CDesc& operator>> (const FW_CDesc& desc, FW_CColor& color);

FW_CDesc& operator<< (FW_CDesc& desc, const FW_SPlatformPoint& thePoint);
const FW_CDesc& operator>> (const FW_CDesc& desc, FW_SPlatformPoint& thePoint);

void FW_InsertScriptableIntoDesc(const FW_MScriptable* scriptable, FW_CDesc& desc);
FW_MScriptable* FW_ExtractScriptableFromDesc(const FW_CDesc& desc);

#endif // FWDSCOPR_H