//========================================================================================
//
//	File:				FWPrtScp.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPRTSCP_H
#define FWPRTSCP_H

#ifndef FWSCPTBL_H
#include "FWScptbl.h"
#endif

//========================================================================================
//	forward declarations
//========================================================================================

class ODObjectSpec;

//========================================================================================
//	class FW_MPartScriptable
//========================================================================================

class FW_MPartScriptable : public FW_MScriptable
{
public:
	FW_DECLARE_CLASS
	FW_DECLARE_AUTO(FW_MPartScriptable)

	FW_MPartScriptable();
	virtual ~FW_MPartScriptable();

	virtual ODDescType				GetObjectClass() const;
	
	virtual ODDescType				GetSpecifierForm() const;
																											
	virtual void					EmbeddedFrameSpec(Environment* ev,
													FW_CPart* part,
													FW_CFrame* embeddedFrame,
													FW_CDesc& objectSpec);
														
	virtual FW_MScriptable* 		GetContainingObject(Environment* ev, FW_CPart* part) const;

	virtual FW_Boolean				GetObjectContainedInPart(Environment* ev,
															ODDescType desiredClass,
															ODDescType form,
															FW_CDesc& selectionData,
															FW_CDesc& containedObjectToken);

	virtual long					CountElementsInPart(Environment* ev, ODDescType desiredClass);
	
	virtual void					BuildObjectSpecifier(Environment* ev,
														FW_CPart* part,
														const FW_CFrame* frame,
														FW_CDesc& specifier,
														ODDescType preferredForm) const;

	virtual FW_Boolean				HasProperty(ODDescType whichProperty) const;
	
	virtual FW_Boolean				GetProperty(Environment* ev,
												FW_CPart* part,
												FW_CDesc& propertyValue,
												ODDescType whichProperty,
												ODDescType desiredType = typeWildCard) const;	

	static void						EmbeddedFrameSpecGlue(Environment* ev,
														FW_CPart* part, 
														ODFrame* embeddedFrame,
														ODObjectSpec* spec);
};

//========================================================================================
//	class FW_MEmbeddingPartScriptable
//========================================================================================

class FW_MEmbeddingPartScriptable : public FW_MPartScriptable
{
public:
	FW_DECLARE_CLASS
	FW_DECLARE_AUTO(FW_MEmbeddingPartScriptable)
	
	FW_MEmbeddingPartScriptable();
	virtual ~FW_MEmbeddingPartScriptable();
};

#endif // FWPRTSCP_H