//========================================================================================
//
//	File:				PRSIGlTy.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef PRSLGLTY_H
#define PRSLGLTY_H

#ifndef __MIXEDMODE__
#include <MixedMode.h>
#endif

#ifndef FWODTYPS_H
#include "FWODTyps.h"
#endif

//========================================================================================
// Forward class declarations
//========================================================================================

class FW_CSemanticInterface;
class ODSession;
class ODAppleEvent;
class ODDesc;
class ODOSLToken;

//========================================================================================
// ProcInfo declarations
//========================================================================================

enum {
	FW_uppCallEventHandlerProcInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(FW_PlatformError)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_CSemanticInterface*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODAppleEvent*)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ODAppleEvent*))),
	FW_uppCallCoercionHandlerProcInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(FW_PlatformError)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_CSemanticInterface*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODDesc*)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ODDescType)))
		| STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(ODDesc*))),
	FW_uppCallPredispatchProcInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(FW_PlatformError)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_CSemanticInterface*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODAppleEvent*)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ODAppleEvent*))),
	FW_uppCallObjectAccessorProcInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(FW_PlatformError)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_CSemanticInterface*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODDescType)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ODOSLToken*)))
		| STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(ODDescType)))
		| STACK_ROUTINE_PARAMETER(6, SIZE_CODE(sizeof(ODDescType)))
		| STACK_ROUTINE_PARAMETER(7, SIZE_CODE(sizeof(ODDesc*)))
		| STACK_ROUTINE_PARAMETER(8, SIZE_CODE(sizeof(ODOSLToken*))),
	FW_uppCallCompareProcInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(FW_PlatformError)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_CSemanticInterface*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODDescType)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ODOSLToken*)))
		| STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(ODOSLToken*)))
		| STACK_ROUTINE_PARAMETER(6, SIZE_CODE(sizeof(ODBoolean*))),
	FW_uppCallCountProcInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(FW_PlatformError)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_CSemanticInterface*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODDescType)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ODDescType)))
		| STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(ODOSLToken*)))
		| STACK_ROUTINE_PARAMETER(6, SIZE_CODE(sizeof(ODSLong*))),
	FW_uppCallDisposeTokenProc = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(FW_PlatformError)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_CSemanticInterface*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODOSLToken*))),
	FW_uppCallGetErrDescProcInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(FW_PlatformError)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_CSemanticInterface*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODDesc**))),
	FW_uppCallGetMarkTokenProcInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(FW_PlatformError)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_CSemanticInterface*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODOSLToken*)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ODDescType)))
		| STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(ODOSLToken*))),
	FW_uppCallMarkProcInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(FW_PlatformError)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_CSemanticInterface*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODOSLToken*)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ODOSLToken*)))
		| STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(ODSLong))),
	FW_uppCallAdjustMarksProcInfo = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(FW_PlatformError)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(FW_CSemanticInterface*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ODSLong)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(ODSLong)))
		| STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(ODOSLToken*)))
};

//========================================================================================
// Universal Procedure Pointer Types
//========================================================================================

typedef UniversalProcPtr FW_CallEventHandlerUPP;
typedef UniversalProcPtr FW_CallCoercionHandlerUPP;
typedef UniversalProcPtr FW_CallPredispatchProcUPP;
typedef UniversalProcPtr FW_CallObjectAccessorProcUPP;
typedef UniversalProcPtr FW_CallCompareProcUPP;
typedef UniversalProcPtr FW_CallCountProcUPP;
typedef UniversalProcPtr FW_CallCountProcUPP;
typedef UniversalProcPtr FW_CallDisposeTokenProcUPP;
typedef UniversalProcPtr FW_CallGetErrDescProcUPP;
typedef UniversalProcPtr FW_CallGetMarkTokenProcUPP;
typedef UniversalProcPtr FW_CallMarkProcUPP;
typedef UniversalProcPtr FW_CallAdjustMarksProcUPP;

//========================================================================================
// Build Routine Descriptor Macros
//========================================================================================

#define FW_RoutDesc_CallEventHandler(procedure) \
	BUILD_ROUTINE_DESCRIPTOR(FW_uppCallEventHandlerProcInfo, procedure)	
#define FW_RoutDesc_CallCoercionHandler(procedure) \
	BUILD_ROUTINE_DESCRIPTOR(FW_uppCallCoercionHandlerProcInfo, procedure)
#define FW_RoutDesc_CallPredispatchProc(procedure) \
	BUILD_ROUTINE_DESCRIPTOR(FW_uppCallPredispatchProcInfo, procedure)
#define FW_RoutDesc_CallObjectAccessorProc(procedure) \
	BUILD_ROUTINE_DESCRIPTOR(FW_uppCallObjectAccessorProcInfo, procedure)
#define FW_RoutDesc_CallCompareProc(procedure) \
	BUILD_ROUTINE_DESCRIPTOR(FW_uppCallCompareProcInfo, procedure)
#define FW_RoutDesc_CallCountProc(procedure) \
	BUILD_ROUTINE_DESCRIPTOR(FW_uppCallCountProcInfo, procedure)
#define FW_RoutDesc_CallDisposeTokenProc(procedure) \
	BUILD_ROUTINE_DESCRIPTOR(FW_uppCallDisposeTokenProc, procedure)
#define FW_RoutDesc_CallGetErrDescProc(procedure) \
	BUILD_ROUTINE_DESCRIPTOR(FW_uppCallGetErrDescProcInfo, procedure)
#define FW_RoutDesc_CallGetMarkTokenProc(procedure) \
	BUILD_ROUTINE_DESCRIPTOR(FW_uppCallGetMarkTokenProcInfo, procedure)
#define FW_RoutDesc_CallMarkProc(procedure) \
	BUILD_ROUTINE_DESCRIPTOR(FW_uppCallMarkProcInfo, procedure)
#define FW_RoutDesc_CallAdjustMarksProc(procedure) \
	BUILD_ROUTINE_DESCRIPTOR(FW_uppCallAdjustMarksProcInfo, procedure)

//========================================================================================
// Callback pointer block
//========================================================================================

FW_EXTERN_C_BEGIN

struct FW_SSemIntGlueProcs
{
	FW_CallEventHandlerUPP				_fCallEventHandlerGlue;
	FW_CallCoercionHandlerUPP			_fCallCoercionHandlerGlue;
	FW_CallPredispatchProcUPP			_fCallPredispatchProcGlue;
	FW_CallObjectAccessorProcUPP		_fCallObjectAccessorGlue;
	FW_CallCompareProcUPP				_fCallCompareProcGlue;
	FW_CallCountProcUPP					_fCallCountProcGlue;
	FW_CallDisposeTokenProcUPP			_fCallDisposeTokenProcGlue;
	FW_CallGetErrDescProcUPP			_fCallGetErrDescProcGlue;
	FW_CallGetMarkTokenProcUPP			_fCallGetMarkTokenProcGlue;
	FW_CallMarkProcUPP					_fCallMarkProcGlue;
	FW_CallAdjustMarksProcUPP			_fCallAdjustMarksProcGlue;
};

FW_EXTERN_C_END

#endif // PRSIGLTY_H
