//========================================================================================
//
//	File:				FWGrowBx.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWGROWBX_H
#define FWGROWBX_H

#ifndef FWVIEW_H
#include "FWView.h"
#endif

#ifndef FWRUNTYP_H
#include "FWRunTyp.h"
#endif

//========================================================================================
//	Forward Class Definitions
//========================================================================================

class FW_CFrame;
class FW_CActivateEvent;

//========================================================================================
//	CLASS FW_CGrowBox
//========================================================================================

class FW_CGrowBox : public FW_CView
{
public:
	FW_DECLARE_CLASS

//----------------------------------------------------------------------------------------
//	Initialization/destruction
//
public:
	// One-step construction
	FW_CGrowBox(Environment* ev, 
				FW_CSuperView* container, 
				ODID id,
				const FW_CPoint& location);
				
	virtual ~FW_CGrowBox();	

private:
	// Two-step construction
	FW_CGrowBox(Environment* ev);

//----------------------------------------------------------------------------------------
//	Inherited API
//
public:
	virtual void 		Draw(Environment* ev, ODFacet* facet, ODShape* invalidShape);
	virtual void		DoActivateEvent(Environment *ev, const FW_CActivateEvent& theActivateEvent);
	
// ----- Archiving -----
	static void*		Create(FW_CReadableStream& stream, FW_ClassTypeConstant type);
	static void			Destroy(void* object, FW_ClassTypeConstant type);
	virtual void		Flatten(Environment*ev, FW_CWritableStream& stream) const;
	virtual void		InitializeFromStream(Environment*ev, FW_CReadableStream& stream);
};

#endif
