//========================================================================================
//
//	File:				FWWinPro.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWFrameW.hpp"

#ifndef FWWINPRO_H
#include "FWWinPro.h"
#endif

#ifndef SLWINDOW_H
#include "SLWindow.h"
#endif

#ifndef FWWINDOW_H
#include "FWWindow.h"
#endif

#ifndef FWDEBUG_H
#include "FWDebug.h"
#endif

// ----- OpenDoc Utilities -----

#ifndef _STDTYPIO_
#include "StdTypIO.h"
#endif

#ifndef _STORUTIL_
#include <StorUtil.h>
#endif

// ----- OpenDoc Includes -----

#ifndef SOM_ODFrame_xh
#include <Frame.xh>
#endif

#if defined(__MWERKS__) && GENERATING68K
// A hack to work around a bug
#pragma import list somGetGlobalEnvironment
#endif

//========================================================================================
//	Runtime Info
//========================================================================================

#ifdef FW_BUILD_MAC
#pragma segment fwwindow
#endif

FW_DEFINE_AUTO(FW_CWindowProperties)

//========================================================================================
//	class FW_CWindowProperties
//========================================================================================

//----------------------------------------------------------------------------------------
//	FW_CWindowProperties::FW_CWindowProperties
//----------------------------------------------------------------------------------------

FW_CWindowProperties::FW_CWindowProperties()
{
	FW_PrivInitWindowProperties(this);
}

//----------------------------------------------------------------------------------------
//	FW_CWindowProperties::~FW_CWindowProperties
//----------------------------------------------------------------------------------------

FW_CWindowProperties::~FW_CWindowProperties()
{
	if (fSourceFrame)
		fSourceFrame->Release(somGetGlobalEnvironment());
}

//----------------------------------------------------------------------------------------
//	FW_CWindowProperties::ReadWindowProperties
//----------------------------------------------------------------------------------------

FW_Boolean FW_CWindowProperties::ReadWindowProperties(Environment* ev, ODFrame* frame)
{
	FW_Boolean result = FW_PrivReadWindowProperties(ev, this, frame);
	FW_FailOnEvError(ev);
	
	return result;
}
