//========================================================================================
//
//	File:				FWFrameW.hpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWFRAMEW_HPP
#define FWFRAMEW_HPP


#ifndef FW_USE_PRECOMPILED_HEADERS
#define FW_USE_PRECOMPILED_HEADERS 0
#endif

#ifndef FW_AGGRESSIVE_PRECOMPILE
#define FW_AGGRESSIVE_PRECOMPILE 0
#endif

#ifndef FW_PRECOMPILE_PRIVATE_HEADERS
#define FW_PRECOMPILE_PRIVATE_HEADERS 0
#endif

// Generally we want the OpenDoc headers,
// but it can be convenient to turn them off.
// For now, we hand edit the following
// #if when we need to turn them off.

#ifndef FW_PRECOMPILE_OPENDOC_HEADERS
#define FW_PRECOMPILE_OPENDOC_HEADERS 1
#endif

//========================================================================================
// 	Always Needed Includes
//========================================================================================
// 	Environment definition file must be first

#ifndef FWENVDEF_H
#include "FWEnvDef.h"
#endif

#ifndef FWODTYPS_H
#include "FWODTyps.h"
#endif

//========================================================================================
//	Layer Includes
//========================================================================================

#if FW_USE_PRECOMPILED_HEADERS

#include <StdDefs.xh>		// Always need this one

// ----- Foundation Layer -----

#ifndef FWFOUND_H
#include "FWFound.h"
#endif

// ----- OS Layer -----

#ifndef FWOS_H
#include "FWOS.h"
#endif

// ----- OpenDoc Includes -----

#if FW_PRECOMPILE_OPENDOC_HEADERS

// These are all of the OpenDoc Includes in the
// CPlusPlus folder as of OpenDoc 1.0.

#include <Arbitrat.xh>
#include <Canvas.xh>
#include <CanvasB.xh>
#include <Clipbd.xh>
#include <CmdDefs.xh>
#include <DgItmIt.xh>
#include <DispMod.xh>
#include <Disptch.xh>
#include <Document.xh>
#include <Draft.xh>
#include <DragDrp.xh>
#include <EmbFrItr.xh>
#include <ErrorDef.xh>
#include <Extensn.xh>
#include <Facet.xh>
#include <FacetItr.xh>
#include <Foci.xh>
#include <FocusItr.xh>
#include <FocusMod.xh>
#include <FocusOwn.xh>
#include <FocusSet.xh>
#include <Frame.xh>
#include <FrFaItr.xh>
#include <GeoTypes.xh>
#include <Info.xh>
#include <Link.xh>
#include <LinkB.xh>
#include <LinkMgr.xh>
#include <LinkSpcB.xh>
#include <LinkSpec.xh>
#include <LinkSrc.xh>
#include <LinkSrcB.xh>
#include <MenuBar.xh>
#include <MssgIntf.xh>
#include <NamRslvr.xh>
#include <NamSpac.xh>
#include <NmSpcMg.xh>
#include <ObjctItr.xh>
#include <ObjectNS.xh>
#include <ODAdrDes.xh>
#include <ODAplEvt.xh>
#include <ODBindng.xh>
#include <ODCtr.xh>
#include <ODDesc.xh>
#include <ODDesLst.xh>
#include <ODObject.xh>
#include <ODObjSpc.xh>
#include <ODOSLTkn.xh>
#include <ODRecord.xh>
#include <ODRgstry.xh>
#include <ODSessn.xh>
#include <ODSessnB.xh>
#include <ODStor.xh>
#include <ODTypesB.xh>
#include <ODTypesM.xh>
#include <Part.xh>
#include <PfTLItr.xh>
#include <PfTypLs.xh>
#include <Polygon.xh>
#include <PstObj.xh>
#include <RefCtObj.xh>
#include <SemtIntB.xh>
#include <Settings.xh>
#include <Shape.xh>
#include <ShapeB.xh>
#include <StdDefs.xh>
#include <StdExts.xh>
#include <StdProps.xh>
#include <StdTypes.xh>
#include <StorageU.xh>
#include <SUCursor.xh>
#include <SURefItr.xh>
#include <SUView.xh>
#include <Translt.xh>
#include <Trnsform.xh>
#include <TrnsfrmB.xh>
#include <TypeList.xh>
#include <TypLsItr.xh>
#include <Undo.xh>
#include <ValueItr.xh>
#include <ValueNS.xh>
#include <Window.xh>
#include <WinIter.xh>
#include <WinStat.xh>

#endif

// ----- Framework Layer -----

// We consider precompiling headers in this layer for this layer aggressive,
// as opposed to just precompiling things this layer uses.

#if FW_AGGRESSIVE_PRECOMPILE

#ifndef FWFRAMEW_H
#include "FWFrameW.h"
#endif

#endif	// FW_AGGRESSIVE_PRECOMPILE

#endif 	// FW_USE_PRECOMPILED_HEADERS

#endif 	// FWFRAMEW_HPP
